BARFIX_VERSION = GetAddOnMetadata("BarFix", "Version");

-- Binding Variables
BINDING_HEADER_BARFIX_TITLE					= "BarFix";
BINDING_NAME_BARFIX_COMMAND_1				= "Toggle moving anchor";
BINDING_NAME_BARFIX_COMMAND_2				= "Refresh bars";
BINDING_NAME_BARFIX_COMMAND_3				= "Reset bars";
--BINDING_NAME_BARFIX_COMMAND_5				= "Reserved";

local MAIN_ACTION_BAR_STRING				= "MainActionBar";
local BONUS_ACTION_BAR_STRING				= "BonusActionBar";
local MULTI_BAR_BOTTOM_LEFT_STRING	= "MultiBarBottomLeft";
local MULTI_BAR_BOTTOM_RIGHT_STRING = "MultiBarBottomRight";
local MULTI_BAR_LEFT_STRING					= "MultiBarLeft";
local MULTI_BAR_RIGH_STRING					= "MultiBarRight";

local BONUS_ACTION_BUTTON_STRING		= "BonusActionButton";

BarNameList = {
			["ActionButton"]							= MAIN_ACTION_BAR_STRING,
			["MultiBarBottomLeftButton"]	= MULTI_BAR_BOTTOM_LEFT_STRING,
			["MultiBarBottomRightButton"] = MULTI_BAR_BOTTOM_RIGHT_STRING,
			["MultiBarLeftButton"]				= MULTI_BAR_LEFT_STRING,
			["MultiBarRightButton"]				= MULTI_BAR_RIGH_STRING,
}

local LeftButtonString							= "LeftButton";
local RightButtonString							= "RightButton";
local MiddleButtonString						= "MiddleButton";

BarFixSettings = { };

local obj = nil;
local objGrpName = "";

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	--this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("UPDATE_TICKET");

	SLASH_BARFIX1 = "/barfix";
	SLASH_BARFIX2 = "/bf";
	SlashCmdList["BARFIX"] = function() BarFix_ToggleBarFixButton(); end;
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_OnEvent()
	--BarFix_Message("BarFix Event: " .. event);
	if (event == "VARIABLES_LOADED") then
		BarFix_Message("BarFix Loaded");
		BarFix_LoadSettings();
		BarFix_FixBars();
	end
	if (event == "PLAYER_ENTERING_WORLD" or event == "UPDATE_TICKET") then
		BarFix_Fix_PerformanceBarFrame(); --    <-- THIS MUST BE DONE HERE --
		BarFix_FixBars();
		--BarFix_LoadSettings();
	end
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_Command(id, keystate)
	if (id==1) then
		BarFix_ToggleBarFixButton();
	elseif (id==2) then
		BarFix_FixBars();
	elseif (id==3) then
		BarFixSettings = { };
		BarFix_LoadSettings();
		BarFix_Message("BarFix - Bars is now reset.");
		BarFix_FixBars();
	else
		BarFix_Message( "Unknown BarFix_Command: " .. id );
	end
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_LoadSettings()
--[[
	BarFixSettings[MAIN_ACTION_BAR_STRING]				= {x=300,  y=-750, scale=1, alpha=1, spacing=6, mode="h", buttons=12};
	BarFixSettings[MULTI_BAR_BOTTOM_LEFT_STRING]	= {x=300,  y=-700, scale=1, alpha=1, spacing=6, mode="h", buttons=12};
	BarFixSettings[MULTI_BAR_BOTTOM_RIGHT_STRING] = {x=300,  y=-650, scale=1, alpha=1, spacing=6, mode="h", buttons=12};
	BarFixSettings[MULTI_BAR_LEFT_STRING]					= {x=0,		 y=-200, scale=1, alpha=1, spacing=6, mode="v", buttons=12};
	BarFixSettings[MULTI_BAR_RIGH_STRING]					= {x=0,		 y=-200, scale=1, alpha=1, spacing=6, mode="v", buttons=12};
]]--

	BarFixSettings[MAIN_ACTION_BAR_STRING]				= BarFixSettings[MAIN_ACTION_BAR_STRING] or {x=600,  y=-1160, scale=1, alpha=1, spacing=6, mode="h", buttons=12};
	BarFixSettings[MULTI_BAR_BOTTOM_LEFT_STRING]	= BarFixSettings[MULTI_BAR_BOTTOM_LEFT_STRING] or {x=600,  y=-1117, scale=1, alpha=1, spacing=6, mode="h", buttons=12};
	BarFixSettings[MULTI_BAR_BOTTOM_RIGHT_STRING] = BarFixSettings[MULTI_BAR_BOTTOM_RIGHT_STRING] or {x=600,  y=-1075, scale=1, alpha=1, spacing=6, mode="h", buttons=12};
	BarFixSettings[MULTI_BAR_LEFT_STRING]					= BarFixSettings[MULTI_BAR_LEFT_STRING] or {x=1460, y=-170 , scale=1, alpha=1, spacing=6, mode="v", buttons=12};
	BarFixSettings[MULTI_BAR_RIGH_STRING]					= BarFixSettings[MULTI_BAR_RIGH_STRING] or {x=1460, y=-695 , scale=1, alpha=1, spacing=6, mode="v", buttons=12};

end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_Message(text)
	DEFAULT_CHAT_FRAME:AddMessage( text, 1, 0.5, 0.5 );
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_Move(Move)
	if (Move==true or Move==1) then
		--obj = GetMouseFocus();--:GetParent();
		--BarFixButton:SetBackdropColor(1, 1, 1, 0.5);
		--BarFixText:SetText("Moving: " .. obj:GetName());
		--if (obj == WorldFrame) then return; end
		--obj:SetClampedToScreen(true);
		obj:SetMovable(1);
		obj:StartMoving();
		obj.isMoving = true;
	else
		--BarFix_Message("Stopped Moving: " .. obj:GetName());
		obj:StopMovingOrSizing();
		obj.isMoving = false;
		obj:SetMovable(0);
		local settings = BarFixSettings[BarNameList[objGrpName]];
		settings.point = {obj:GetPoint()};
		settings.x = settings.point[4];
		settings.y = settings.point[5];
		settings.point = nil;
	end
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function BarFix_OnMouseWheel(arg1)
	if (arg1 == 1) then
		BarFix_OnMouseDown(LeftButtonString);
	else
		BarFix_OnMouseDown(RightButtonString);
	end
end
--[[
]]
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_OnMouseDown(button_clicked)
	--BarFixText:SetText(button_clicked);
	--BarFix_Message( "button_clicked: " .. button_clicked );

	local settings = BarFixSettings[BarNameList[objGrpName]];

	if ( button_clicked == LeftButtonString) then

		if (IsControlKeyDown() and IsShiftKeyDown() ) then
			-- Mode code here
			BarFix_FixBarButtons("h", nil, nil);

		elseif (IsAltKeyDown() and IsControlKeyDown()) then
			-- +Button code here
			if (settings.buttons < 12) then BarFix_FixBarButtons(nil, nil, settings.buttons + 1); end

		elseif (IsControlKeyDown()) then
			BarFix_SetScale(settings.scale + 0.01);


		elseif (IsAltKeyDown()) then
			BarFix_SetAlpha(settings.alpha + 0.05);

		elseif (IsShiftKeyDown()) then
			-- +Margin code here
			BarFix_FixBarButtons(nil, settings.spacing + 1, nil);

		elseif (not IsModifierKeyDown()) then
			BarFix_Move(true);

		end

	elseif ( button_clicked == RightButtonString) then

		if (IsControlKeyDown() and IsShiftKeyDown() ) then
			-- Mode code here
			BarFix_FixBarButtons("v", nil, nil);

		elseif (IsControlKeyDown() and IsAltKeyDown()) then
			-- -Button code here
			if (settings.buttons > 1) then BarFix_FixBarButtons(nil, nil, settings.buttons - 1); end

		elseif (IsControlKeyDown()) then
			BarFix_SetScale(settings.scale - 0.01);

		elseif (IsAltKeyDown()) then
			BarFix_SetAlpha(settings.alpha - 0.05);

		elseif (IsShiftKeyDown()) then
			-- -Margin code here
			BarFix_FixBarButtons(nil, settings.spacing -1, nil);

		elseif (not IsModifierKeyDown()) then
			BarFix_ToggleBarFixButton();
			GameTooltip:Hide();

		end

	elseif ( button_clicked == MiddleButtonString) then
		if (IsShiftKeyDown()) then
		elseif (IsAltKeyDown()) then
		elseif (IsControlKeyDown()) then
		end
	end
		
	if (BarFixButton:IsVisible()) then BarFix_ShowTooltips(); end
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_ShowTooltips()
	local settings = BarFixSettings[BarNameList[objGrpName]];
	GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT", 0);
	GameTooltip:SetText(BarNameList[objGrpName] .. "\n\n", 1.0, 0.8, 0.0);

	--GameTooltip:AddDoubleLine(textL, textR, rL, gL, bL, rR, gR, bR) 

	GameTooltip:AddDoubleLine("LeftClick+Drag", "Move bar", 1, 1, 1, 1, 1, 1);
	GameTooltip:AddDoubleLine("RightClick", "Exit edit mode", 1, 1, 1, 1, 1, 1);
	GameTooltip:AddDoubleLine("Alt+Click/Wheel", " +/- Alpha", 1, 1, 1, 1, 1, 1);
	GameTooltip:AddDoubleLine("Ctrl+Click/Wheel", " +/- Scale", 1, 1, 1, 1, 1, 1);
	GameTooltip:AddDoubleLine("Shift+Click/Wheel", " +/- Margin", 1, 1, 1, 1, 1, 1);
	GameTooltip:AddDoubleLine("Ctrl+Alt+Click/Wheel", " +/- Button", 1, 1, 1, 1, 1, 1);
	GameTooltip:AddDoubleLine("Ctrl+Shift+Click/Wheel", " +/- Mode", 1, 1, 1, 1, 1, 1);

	GameTooltip:AddLine(" ");

	GameTooltip:AddDoubleLine("Alpha: " .. format("%.2f", settings.alpha), "Scale: " .. format("%.2f", settings.scale));
	GameTooltip:AddDoubleLine("Margin: " .. settings.spacing, "Buttons: " .. settings.buttons);
	GameTooltip:AddDoubleLine("X: " .. format("%.2f", settings.x), "Y: " .. format("%.2f", settings.y));
	GameTooltip:SetPadding(0);
	GameTooltip:Show();
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_ToggleBarFixButton()
	if (BarFixButton:IsVisible()) then
		BarFixButton:Hide();
	else
		local focusedObj = GetMouseFocus();
		objGrpName = string.gsub(focusedObj:GetName(), tostring(focusedObj:GetID()), "");
		--BarFix_Message( focusedObj:GetName() .. "  >>>  " .. objGrpName );
		if (BarNameList[objGrpName]) then
			UIFrameFlash(BarFixButton, 0.05, 0.05, 0.3, true, 0.05, 0.05);
		else
			PlaySoundFile("Sound\\interface\\Error.wav");
			BarFix_Message( "[BarFix] No bar found! \n            Hold the mouse cursor over a bar and try again." );
		end
		--BarFixButton:Show();
	end
	BarFix_ToggleEditMode();
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_ToggleEditMode()
	--BarFix_Message( "Show: " .. tostring(BarFixText:IsVisible()) );

	if ( BarFixButton:IsVisible() ) then
		PlaySound("igBonusBarOpen");
		
		--DEFAULT_CHAT_FRAME:AddMessage( string.gsub(focusedObj:GetName(), tostring(focusedObj:GetID()), "1") );
		
		obj = getglobal(objGrpName .. "1");
		if (not obj) then return; end

		--DEFAULT_CHAT_FRAME:AddMessage( obj:GetName() );

		BarFixButton:SetParent(obj);
		BarFixButton:ClearAllPoints();
		BarFixButton:SetPoint("BOTTOMLEFT", obj, "TOPLEFT", -4, 0);
		BarFixButton:SetFrameStrata("DIALOG");
		--BarFixButton:Show();

		-- Show frame
		--[[
		BarFixButton:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",  
																							edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
																							tile = true, tileSize = 16, edgeSize = 16, 
																							insets = { left = 5, right = 5, top = 5, bottom = 5 }});
		BarFixButton:SetBackdropColor(0, 0, 0);
		BarFixButton:EnableMouse(true);
		]]
		--BarFixButton:SetBackdropBorderColor(0.5, 0.5, 0.5);
	else
		PlaySound("igMainMenuOptionCheckBoxOff");
		
		-- Hide frame
		--[[
		BarFixButton:SetBackdrop({bgFile = "", edgeFile = "", tile = false, tileSize = 0, edgeSize = 0, 
														insets = { left = 0, right = 0, top = 0, bottom = 0 }});
		BarFixButton:EnableMouse(false);
		]]
		BarFixButton:SetParent(UIParent);
		BarFixButton:ClearAllPoints();
		BarFixButton:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0);
		--BarFixButton:Hide();
		
	end
	
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_SetAlpha(alpha)
	if ( (alpha < -0.05) or (alpha > 1) ) then return; end
	local settings = BarFixSettings[BarNameList[objGrpName]];
	settings.alpha = alpha;
	local tmpObj = nil;
	for i=1, 12 do
		tmpObj = getglobal(objGrpName..i);
		tmpObj:SetAlpha(settings.alpha);
	end
	if (BarNameList[objGrpName] == MAIN_ACTION_BAR_STRING) then
		BonusActionBarFrame:SetAlpha(settings.alpha);
	end
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_SetScale(scale)

--------------------------------------------------------------------------------------------------
--------- DEBUG CODE -----------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
--[[
local minx,miny,width,height = obj:GetRect() 
DEFAULT_CHAT_FRAME:AddMessage(format("\nminx: %s miny: %s width: %s height: %s", tostring(minx), tostring(miny), tostring(width), tostring(height)));

minx,miny,width,height = obj:GetBoundsRect() 
DEFAULT_CHAT_FRAME:AddMessage(format("\nminx: %s miny: %s width: %s height: %s", tostring(minx), tostring(miny), tostring(width), tostring(height)));
]]
--DEFAULT_CHAT_FRAME:AddMessage("\n" .. tostring(minx) .. "\n" ..  tostring(miny) .. "\n" .. tostring(width) .. "\n" .. tostring(height));
--------------------------------------------------------------------------------------------------
--------- DEBUG CODE -----------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------

	local settings = BarFixSettings[BarNameList[objGrpName]];
	settings.scale = scale;
	local tmpObj = nil;
	for i=1, 12 do
		tmpObj = getglobal(objGrpName..i);
		tmpObj:SetScale(settings.scale);
	end
	if (BarNameList[objGrpName] == MAIN_ACTION_BAR_STRING) then
		BonusActionBarFrame:SetScale(settings.scale);
	end
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

--function BarFix_SetMargin(margin)
--end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

--function BarFix_ButtonsAddRemove(buttonNr)
--end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_FixBarButtons(mode, margin, nrOfButtonsToShow)

	local point = "";
	local relativePoint = "";
	local xOffset = 0;
	local yOffset = 0;
	local btn = nil;
	local settings = BarFixSettings[BarNameList[objGrpName]];

	--settings.mode = mode;
	--settings.spacing = margin;
	--settings.buttons = settings.buttons;

	if (mode) then settings.mode = mode; end

	--[[
	if (BarNameList[objGrpName] == MAIN_ACTION_BAR_STRING) then
		settings.mode = "h";
	end
	]]

	if (margin) then settings.spacing = margin; end
	if (nrOfButtonsToShow) then settings.buttons = nrOfButtonsToShow; end
	

	if (settings.mode == "h") then
		point = "TOPLEFT";
		relativePoint = "TOPRIGHT";
		xOffset = settings.spacing;
	elseif (settings.mode == "v") then
		point = "TOPLEFT";
		relativePoint = "BOTTOMLEFT";
		yOffset = 0 - settings.spacing;
	end

	for i=2, 12 do
		btn = getglobal(objGrpName .. i);
		btn:SetClampedToScreen(true);
		btn:SetPoint(point, objGrpName .. tostring(i-1), relativePoint, xOffset, yOffset);

		if (BarNameList[objGrpName] == MAIN_ACTION_BAR_STRING) then
			btn:SetParent(UIParent);

			-- Bonus action buttons ------------------------------------------------------------
--DEFAULT_CHAT_FRAME:AddMessage( format("mode: %q    spacing: %s    buttons: %s   xOffset: %s   yOffset: %s", settings.mode, settings.spacing, settings.buttons, xOffset, yOffset) );
			local bonusbtn = getglobal(BONUS_ACTION_BUTTON_STRING .. i);
			--bonusbtn:SetClampedToScreen(true);
			bonusbtn:ClearAllPoints();
			bonusbtn:SetAllPoints(btn);
	
	
			--bonusbtn:SetPoint(point, BONUS_ACTION_BUTTON_STRING .. tostring(i-1), relativePoint, xOffset, yOffset);
--[[
			if (i > settings.buttons)then
				bonusbtn:Hide();
--DEFAULT_CHAT_FRAME:AddMessage( bonusbtn:GetName() .. " - hide");
			else
--DEFAULT_CHAT_FRAME:AddMessage( bonusbtn:GetName() .. " - show");
				bonusbtn:Show();
			end
			-- Bonus action buttons ------------------------------------------------------------
]]
		end


		if (i > settings.buttons)then
			btn:Hide();
		else
			btn:Show();
		end

	end

--DEFAULT_CHAT_FRAME:AddMessage( format("mode: %q    spacing: %s    buttons: %s   xOffset: %s   yOffset: %s", settings.mode, settings.spacing, settings.buttons, xOffset, yOffset) );

end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_FixBars()

	BarFixButton:Hide();

	BarFix_Message("BarFix - Refreshing bars...");

	local myFrames = { MainMenuBar, MainMenuBarArtFrame };

	for i, obj in ipairs(myFrames) do
		obj:ClearAllPoints();
		obj:EnableMouse(false);
		obj:Hide();
	end

	BarFix_Fix_ExpRep_Bars();
	BarFix_Fix_MainActionBar();
	BarFix_Fix_BonusActionBar();
	BarFix_Fix_ShapeshiftBar();
	BarFix_Fix_MultiBars();

	for frameName in pairs(BarNameList) do
		--DEFAULT_CHAT_FRAME:AddMessage( frameName .. "   -   " .. BarNameList[frameName], 0, 1, 1);
		objGrpName = frameName;
		local settings = BarFixSettings[BarNameList[frameName]];
		BarFix_FixBarButtons(settings.mode, settings.spacing, settings.buttons);
		BarFix_SetAlpha(settings.alpha);
		BarFix_SetScale(settings.scale);
	end

	MainMenuBar:Show(); -- <<< THIS LINE IS VERY IMPORTENT FOR THE BonusActionBar to SHOW !!

end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- Fix main Action bar
function BarFix_Fix_MainActionBar()
	
	local settings = BarFixSettings[MAIN_ACTION_BAR_STRING];
	
	--[[
	for i=1, 12 do
		btn = getglobal("ActionButton" .. i);
		btn:SetParent(UIParent);
		--btn:SetClampedToScreen(true);
	end
	]]
	
	ActionButton1:SetParent(UIParent);
	ActionButton1:SetClampedToScreen(true);
	ActionButton1:ClearAllPoints();
	ActionButton1:SetPoint("TOPLEFT", ActionButton1:GetParent(), "TOPLEFT", settings.x, settings.y);
	ActionButton1:SetScale(settings.scale);
	ActionButton1:SetAlpha(settings.alpha);

end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- Fix Bonus Action bar
function BarFix_Fix_BonusActionBar()

	--local settings = BarFixSettings[MAIN_ACTION_BAR_STRING];


	--BonusActionButton1:SetParent(ActionButton1);
	--BonusActionButton1:SetClampedToScreen(true);
	BonusActionButton1:ClearAllPoints();
	--BonusActionButton1:SetPoint(ActionButton1:GetPoint());
	BonusActionButton1:SetAllPoints(ActionButton1);
	
--[[
	BonusActionButton1:ClearAllPoints();
	
	BonusActionButton1:SetScale(ActionButton1:GetScale());
	BonusActionButton1:SetAlpha(ActionButton1:GetAlpha());

	BonusActionButton1:SetAllPoints(ActionButton1);
]]	
--BonusActionBarFrame:SetHeight(1);
--BonusActionBarFrame:SetWidth(1);
	--BonusActionBarFrame:SetParent(UIParent);
	--BonusActionBarFrame:ClearAllPoints();
	--BonusActionBarFrame:SetPoint(ActionButton1:GetPoint());
	--BonusActionBarFrame:EnableMouse(false);
	--BonusActionBarTexture0:SetTexture();
	--BonusActionBarTexture1:SetTexture();
end
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- Fix Multi Bars
function BarFix_Fix_MultiBars()

	--local settings = nil;

	local bar_names = {MULTI_BAR_BOTTOM_LEFT_STRING, 
										MULTI_BAR_BOTTOM_RIGHT_STRING, 
										MULTI_BAR_LEFT_STRING,
										MULTI_BAR_RIGH_STRING};
	
	for i, barname in ipairs(bar_names) do
		--BarFix_Message(i .. " - " .. barname);
		local bar = getglobal(barname);
		--settings = BarFixSettings[barname];

--[[
		for j=2, 12 do
			local btn = getglobal(barname .. "Button" .. j);
			--BarFix_Message(btn:GetName());
			--btn:SetParent(UIParent);
			--btn:SetClampedToScreen(true);
		end

		--bar:Hide();
	]]
	
		bar:SetParent(UIParent);
		bar:ClearAllPoints();
		--bar:SetPoint("TOPLEFT", UIParent, "TOPLEFT", settings.x, settings.y);
		bar:SetPoint("TOPLEFT", UIParent);
		bar:SetWidth(1);
		bar:SetHeight(1);
		--bar:SetScale(settings.scale);
		--bar:SetAlpha(settings.alpha);
	end


	MultiBarLeftButton1:ClearAllPoints();
	MultiBarLeftButton1:SetPoint("TOPLEFT", UIParent, "TOPLEFT", BarFixSettings[MULTI_BAR_LEFT_STRING].x, BarFixSettings[MULTI_BAR_LEFT_STRING].y);
	MultiBarLeftButton1:SetClampedToScreen(true);

	MultiBarRightButton1:ClearAllPoints();
	MultiBarRightButton1:SetPoint("TOPLEFT", UIParent, "TOPLEFT", BarFixSettings[MULTI_BAR_RIGH_STRING].x, BarFixSettings[MULTI_BAR_RIGH_STRING].y);
	MultiBarRightButton1:SetClampedToScreen(true);

	MultiBarBottomLeftButton1:ClearAllPoints();
	MultiBarBottomLeftButton1:SetPoint("TOPLEFT", UIParent, "TOPLEFT", BarFixSettings[MULTI_BAR_BOTTOM_LEFT_STRING].x, BarFixSettings[MULTI_BAR_BOTTOM_LEFT_STRING].y);
	MultiBarBottomLeftButton1:SetClampedToScreen(true);

	MultiBarBottomRightButton1:ClearAllPoints();
	MultiBarBottomRightButton1:SetPoint("TOPLEFT", UIParent, "TOPLEFT", BarFixSettings[MULTI_BAR_BOTTOM_RIGHT_STRING].x, BarFixSettings[MULTI_BAR_BOTTOM_RIGHT_STRING].y);
	MultiBarBottomRightButton1:SetClampedToScreen(true);

end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_Fix_ShapeshiftBar()
	
	local settings = BarFixSettings[MAIN_ACTION_BAR_STRING];

	ShapeshiftBarFrame:ClearAllPoints();
	ShapeshiftBarFrame:SetParent(UIParent);
	--ShapeshiftBarFrame:SetFrameStrata("LOW");

	ShapeshiftBarFrame:SetPoint("TOPLEFT", ShapeshiftBarFrame:GetParent(), "TOPLEFT", settings.x - 100, settings.y);

	ShapeshiftBarFrame:SetScale(settings.scale);
	ShapeshiftBarFrame:SetAlpha(settings.alpha);
	
	ShapeshiftButton1:EnableMouse(false);
	ShapeshiftButton1:SetAlpha(0);
	ShapeshiftButton1:Hide();

	ShapeshiftButton2:EnableMouse(false);
	ShapeshiftButton2:SetAlpha(0);
	ShapeshiftButton2:Hide();

	ShapeshiftBarFrame:EnableMouse(false);
	ShapeshiftBarFrame:SetAlpha(0);
	ShapeshiftBarFrame:Hide();

end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_Fix_ExpRep_Bars()

	local w = PlayerFrameHealthBar:GetWidth() + 12;
	local h = PlayerFrameHealthBar:GetHeight() / 1.5;

	for i = 0, 3 do
		getglobal("MainMenuXPBarTexture"..i):SetTexture();
		getglobal("MainMenuMaxLevelBar"..i):SetTexture();
		getglobal("ReputationXPBarTexture"..i):SetTexture();
		getglobal("ReputationWatchBarTexture"..i):SetTexture();
	end

	--local x = floor(PlayerFrameManaBar:GetLeft() + 0.5);
	MainMenuExpBar:SetParent(PlayerFrame);
	MainMenuExpBar:SetWidth(w * 0.6);
	MainMenuExpBar:SetHeight(h);
	MainMenuExpBar:ClearAllPoints();
	MainMenuExpBar:SetPoint("TOPLEFT", PlayerFrameManaBar, "BOTTOMLEFT", -12, -2); --<< ska vara -2 inte -20



	ReputationWatchBar:SetParent(MainMenuExpBar);
	ReputationWatchBar:SetWidth(w - MainMenuExpBar:GetWidth());
	ReputationWatchBar:SetHeight(h);
	ReputationWatchBar:ClearAllPoints();
	ReputationWatchBar:SetPoint("TOPLEFT", MainMenuExpBar, "TOPRIGHT", 0, 0);

	ReputationWatchStatusBar:ClearAllPoints();
	ReputationWatchStatusBar:SetAllPoints(ReputationWatchBar);
	
	--HideWatchedReputationBarText("unlock");
	--ShowWatchedReputationBarText("unlock");

	MainMenuExpBar.prefix = nil;

	MainMenuExpBar.lockShow = nil;
	MainMenuExpBar.cvarLocked = nil;
	MainMenuExpBar.textLocked = nil;

	ReputationWatchBar.cvarLocked = nil;
	ReputationWatchBar.textLocked = nil;

--ReputationWatchBarOverlayFrame:EnableMouse(true);
--ReputationWatchBarOverlayFrame:Show();
--[[
ReputationWatchStatusBar:EnableMouse(true);
ReputationWatchStatusBar:Show();

ReputationWatchBar:EnableMouse(true);
ReputationWatchBar:Show();
	
ReputationWatchBar:SetHitRectInsets(210, 210, 210, 210);
ReputationWatchStatusBar:SetHitRectInsets(210, 210, 210, 210);
	]]
--ReputationWatchStatusBarText:Show();


--ReputationWatchBar_Update();

	--ReputationWatchBarOverlayFrame:ClearAllPoints();
	--ReputationWatchBarOverlayFrame:SetAllPoints(ReputationWatchBar);

--ReputationWatchBarOverlayFrame:SetFrameStrata("LOW");




--ReputationWatchStatusBarBackground:SetAllPoints(ReputationWatchBar);
--ReputationWatchStatusBarBackground:SetPoint("TOPLEFT", MainMenuExpBar, "TOPRIGHT", 0, -300);


--BarFixButton:SetPoint(ReputationWatchBar:GetPoint());

--[[
	--ReputationWatchStatusBar:SetPoint(ReputationWatchBar:GetPoint());
	--ReputationWatchStatusBar:SetWidth(w);
	--ReputationWatchStatusBar:SetHeight(h);

	--ReputationWatchStatusBar:ClearAllPoints();
	--ReputationWatchBar:ClearAllPoints();
	--ReputationWatchBar:Hide();
]]


	--ExhaustionTick:Show();

end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- Fix the lag meter
function BarFix_Fix_PerformanceBarFrame()
	MainMenuBarPerformanceBarFrame:SetClampedToScreen(false);
	MainMenuBarPerformanceBarFrame:SetParent(UIParent);
	MainMenuBarPerformanceBarFrame:ClearAllPoints();
	MainMenuBarPerformanceBarFrame:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", 4, -40);
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--[[

function BarFix_Fix_Bars(barname, anchor, relativeTo, relativePoint)
	local obj = getglobal(barname);
	obj:ClearAllPoints();
	obj:SetPoint(anchor, relativeTo, relativePoint, BarFixSettings[barname].x, BarFixSettings[barname].y);
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function BarFix_Fix_MultiBars_2(obj, x, y, scale, alpha, orientation)
	obj:ClearAllPoints();
	obj:SetPoint("BOTTOMLEFT", obj:GetParent(), "BOTTOMLEFT", x, y);
	obj:SetParent(UIParent);
	--obj:SetFrameStrata("LOW");
	obj:SetScale(scale);
	obj:SetAlpha(alpha);
	--orientation
end
]]--
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
